﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel; // ObservableCollection
using System.Collections.Specialized; // NotifyCollectionChangedEventArgs
using System.ComponentModel;          // PropertyChangedEventArgs
using System.Linq;
using System.Text;
using System.Threading;               // SynchronizationContext

namespace ITIN.CSharp.SmartCOM
{

    /// <summary>
    /// Класс, представляющий коллекцию SmartCOM серверов 
    /// </summary>
    public class SmartCOMServerCollection : ObservableCollection<SmartCOMServerConnectionParametrs>
    {
        /// <summary>
        /// Конструктор
        /// </summary>
        public SmartCOMServerCollection()
        {
            //this._dispatcher = SynchronizationContext.Current;
        }

        /// <summary>
        /// Добавить SmartCOM сервер в коллекцию
        /// </summary>
        /// <param name="serverConnectionItem">Экземпляр класса параметров SmartCOM сервера</param>
        public void AddServer(SmartCOMServerConnectionParametrs serverConnectionItem)
        {
            this.Add(serverConnectionItem);          
        }

        /*protected override void OnCollectionChanged(NotifyCollectionChangedEventArgs e) {
            _dispatcher.Post((SendOrPostCallback)delegate { base.OnCollectionChanged(e); }, e);
        }

        protected override void OnPropertyChanged(PropertyChangedEventArgs e) {
            _dispatcher.Post((SendOrPostCallback)delegate { base.OnPropertyChanged(e); }, e);
        }*/

        //private SynchronizationContext _dispatcher;
    }
}
