﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ITIN.CSharp.BaseObjects
{
    public class Test
    {
        public Test()
        {
            var fse = new SafeObservableEvents<Tuple<int, int>>();
            IDisposable unSubscribe1 = fse.Subscribe((intVal) =>
                {
                    int d = intVal.Item1 * intVal.Item2;
                    //MessageLogger.LogMessage("1 " + d.ToString());
                });

            IDisposable unSubscribe2 = fse.Subscribe((intVal) =>
            {
                int d = intVal.Item1 * intVal.Item2;
                //MessageLogger.LogMessage("2 " + d.ToString());
            });

            IDisposable unSubscribe3 = fse.Subscribe((intVal) =>
            {
                int d = intVal.Item1 * intVal.Item2;
                //MessageLogger.LogMessage("3 " + d.ToString());
            });

            fse.Notify(new Tuple<int, int>(10, 20));
            unSubscribe1.Dispose();
            fse.Notify(new Tuple<int, int>(10, 20));
            unSubscribe2.Dispose();
            fse.Notify(new Tuple<int, int>(10, 20));
            unSubscribe2.Dispose();
            fse.Notify(new Tuple<int, int>(10, 20));
            //MessageLogger.LogMessage("Finish");
        }
    }
}
